package gregapi.network;

import gregapi.block.IBlockSyncData;
import net.minecraft.block.Block;
import net.minecraft.world.IBlockAccess;

import com.google.common.io.ByteArrayDataInput;
import com.google.common.io.ByteArrayDataOutput;

/**
 * @author Gregorius Techneticies
 * 
 * Transmits the extended Data of a Block.
 */
public class PacketSyncDataLong extends PacketCoordinates {
	public long mData = 0;
	
	public PacketSyncDataLong(int aDecoderType) {
		super(aDecoderType);
	}
	
	public PacketSyncDataLong(int aX, int aY, int aZ, long aData) {
		super(aX, aY, aZ);
		mData = aData;
	}
	
	@Override
	public byte getPacketIDOffset() {
		return -112;
	}
	
	@Override
	public ByteArrayDataOutput encode2(ByteArrayDataOutput aData) {
		aData.writeLong(mData);
		return aData;
	}
	
	@Override
	public PacketCoordinates decode2(int aX, int aY, int aZ, ByteArrayDataInput aData) {
		return new PacketSyncDataLong(aX, aY, aZ, aData.readLong());
	}
	
	@Override
	public void process(IBlockAccess aWorld, INetworkHandler aNetworkHandler) {
		if (aWorld != null) {
			Block tBlock = aWorld.getBlock(mX, mY, mZ);
			if (tBlock instanceof IBlockSyncData) ((IBlockSyncData)tBlock).receiveDataLong(aWorld, mX, mY, mZ, mData, aNetworkHandler);
		}
	}
}