package gregapi.tileentity;

import gregapi.code.TagData;

/**
 * @author Gregorius Techneticies
 * 
 * Informative Class.
 * 
 * Interface for things like Data Panels and Stuff.
 * Not all Data might be reliable. This is just for Information sake.
 */
public interface ITileEntityEnergyDataCapacitor extends ITileEntityUnloadable {
	/**
	 * This Method may be called by a different Thread. Take that into account when implementing it.
	 * 
	 * Why is there a Side Parameter you ask? I don't know, maybe one Energy Storage for every Side (insert aSide=6 if you don't want to watch for Sides).
	 * 
	 * @param aEnergyType The Type of Energy
	 * @param aSide 0 - 5 = Vanilla Directions of the Implementors Block. 6 = No specific Side (don't do Side checks for this Side)
	 * @return the amount of stored Energy of this kind in this Block. The returned amount is NOT "Math.max"-ed by getEnergyCapacity, so in case you want to display it, you should do that outside of this Block.
	 */
	public long getEnergyStored(TagData aEnergyType, byte aSide);
	
	/**
	 * This Method may be called by a different Thread. Take that into account when implementing it.
	 * 
	 * Why is there a Side Parameter you ask? I don't know, maybe one Energy Storage for every Side (insert aSide=6 if you don't want to watch for Sides).
	 * 
	 * @param aEnergyType The Type of Energy
	 * @param aSide 0 - 5 = Vanilla Directions of the Implementors Block. 6 = No specific Side (don't do Side checks for this Side)
	 * @return the Capacity for this kind of Energy, by this Block.
	 */
	public long getEnergyCapacity(TagData aEnergyType, byte aSide);
}